// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import jakarta.faces.component.behavior.ClientBehaviorHolder;
import jakarta.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIOffcanvas;
import org.apache.myfaces.tobago.layout.OffcanvasPlacement;
import org.apache.myfaces.tobago.model.CollapseMode;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import jakarta.annotation.Generated;
import jakarta.el.ELException;
import jakarta.faces.FacesException;
import jakarta.faces.application.ProjectStage;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import jakarta.el.MethodExpression;
import jakarta.el.ValueExpression;

/**
 Offcanvas component for hidden content that slides into the page.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.OffcanvasTagDeclaration}.
 */
@Generated("component.stg")
public class UIOffcanvas
    extends AbstractUIOffcanvas implements ClientBehaviorHolder {

  private static final Tags TAG = Tags.offcanvas;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "jakarta.faces.Panel";


  enum PropertyKeys {
    markup,
    collapsed,
    customClass,
    tip,
    placement,
    collapsedMode,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Indicating the collapsed state of this component.
  <br>Default: <code>true</code>
  */
  public boolean isCollapsed() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.collapsed);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setCollapsed(boolean collapsed) {
    getStateHelper().put(PropertyKeys.collapsed, collapsed);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.tip);
  }

  public void setTip(java.lang.String tip) {
    getStateHelper().put(PropertyKeys.tip, tip);
  }

  /**
  Defines the placement of the offcanvas. Default is "left".
  <br>Default: <code>left</code><br>Allowed Values: <code>top,left,right,bottom</code>
  */
  public org.apache.myfaces.tobago.layout.OffcanvasPlacement getPlacement() {
    org.apache.myfaces.tobago.layout.OffcanvasPlacement placement = (org.apache.myfaces.tobago.layout.OffcanvasPlacement) getStateHelper().eval(PropertyKeys.placement);
    if (placement != null) {
      return placement;
    }
    return org.apache.myfaces.tobago.layout.OffcanvasPlacement.left;
  }

  public void setPlacement(org.apache.myfaces.tobago.layout.OffcanvasPlacement placement) {
    getStateHelper().put(PropertyKeys.placement, placement);
  }

  /**
  Enum indicating the mode of the collapsed state of this component.
  <br>Default: <code>absent</code>
  */
  public org.apache.myfaces.tobago.model.CollapseMode getCollapsedMode() {
    org.apache.myfaces.tobago.model.CollapseMode collapsedMode = (org.apache.myfaces.tobago.model.CollapseMode) getStateHelper().eval(PropertyKeys.collapsedMode);
    if (collapsedMode != null) {
      return collapsedMode;
    }
    return org.apache.myfaces.tobago.model.CollapseMode.absent;
  }

  public void setCollapsedMode(org.apache.myfaces.tobago.model.CollapseMode collapsedMode) {
    getStateHelper().put(PropertyKeys.collapsedMode, collapsedMode);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}